openapi: 3.0.0
info:
  version: 1.0.0
  title: NSSI API
  description: The API for the NSSI service.
servers:
  - url: http://localhost:8080
    description: Localhost
  - url: https://api.nssi.stage.lincsproject.ca
    description: Staging
  - url: https://api.nssi.lincsproject.ca
    description: Production
tags:
  - name: jobs
    description: Submitting, cancelling, or deleting jobs, and checking job status.
  - name: authorizations
    description: Checking access for available workflows and authorities.
  - name: results
    description: Accessing processing results through NSSI.
  - name: elucidate
    description: Elucidate annotation server.
  - name: uploads
    description: Working with temporary files uploaded to NSSI.
  - name: projects
    description: Creating, viewing, updating, or deleting projects.
  - name: service info
    description: Information about the NSSI service.
paths:
  /actuator/info:
    get:
      summary: Information about the NSSI version currently running.
      operationId: getServiceInfo
      tags:
        - service info
      responses:
        '200':
          description: Success
          content:
            application/vnd.spring-boot.actuator.v3+json:
              schema:
                $ref: '#/components/schemas/ActuatorInfoResponse'
              examples:
                success:
                  value:
                    git:
                      commit:
                        full: 3566a76bb03f0ac076e99fb7d6b24b9c4c44c5ac
                        abbrev: 3566a76
                    build:
                      artifact: Service
                      name: Service
                      time: '2020-11-11T12:43:31.049Z'
                      version: 1.0.0-SNAPSHOT
                      group: ca.sharcnet.nerve
  /actuator/health:
    get:
      summary: Health status of the NSSI service.
      operationId: getServiceHealth
      tags:
        - service info
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                properties:
                  status:
                    type: string
                    description: A string indicating the running state of NSSI.
              examples:
                success:
                  value:
                    status: UP
  /api/jobs/:
    post:
      summary: Creates a new processing job.
      parameters:
        - $ref: '#/components/parameters/AuthHeader'
      operationId: createJob
      x-microcks-operation:
        dispatcher: JSON_BODY
        dispatcherRules: |
          {
            "exp": "/workflow",
            "operator": "equals",
            "cases": {
              "stanford_ner": "ner",
              "stanford_ner_full": "ner",
              "stanford_ner_full_remote": "ner",
              "reconciliation": "recon",
              "default": "error"
            }
          } 
      tags:
        - jobs
      security:
        - bearerAuth: []
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SubmissionRequest'
            examples:
              ner:
                value:
                  workflow: stanford_ner
              recon:
                value:
                  workflow: reconciliation
              error:
                value:
                  workflow: not_a_workflow
          multipart/form-data:
            schema:
              properties:
                file:
                  type: string
                  description: A binary string containing the file to upload.
                  format: binary
                  example: <file data>
                request:
                  $ref: '#/components/schemas/SubmissionRequest'
      responses:
        '202':
          description: Accepted
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/JobInfo'
              examples:
                ner:
                  value:
                    jobId: 1{{ now(hss) }}
                    resultsUri: /api/results/{{ request.body/workflow }}/1{{ now(hss) }}
                    status: IN_PROGRESS
                recon:
                  value:
                    jobId: 5{{ now(hss) }}
                    resultsUri: /api/results/{{ request.body/workflow }}/5{{ now(hss) }}
                    status: IN_PROGRESS
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '500':
          description: Server Error
          content:
            application/json:
              schema: {}
              examples:
                error:
                  value: An error occurred with your request.
  /api/jobs/{jobId}:
    get:
      summary: >-
        Returns information, including status and results URI, for the given
        job.
      operationId: getJob
      x-microcks-operation:
        dispatcher: SCRIPT
        dispatcherRules: |
          def path = mockRequest.getRequest().getServletPath()
          def jobId = path.substring(30)

          if (jobId.startsWith("5"))
          {
            return "recon"
          }
          else
          return "ner"
      tags:
        - jobs
      security:
        - bearerAuth: []
      parameters:
        - name: jobId
          in: path
          schema:
            type: integer
          examples:
            recon:
              value: 11
            ner:
              value: 11
          description: The job ID.
          required: true
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/JobInfo'
              examples:
                recon:
                  value:
                    jobId: '{{ request.path[3] }}'
                    resultsUri: /api/results/reconciliation/{{ request.path[3] }}
                    status: READY
                ner:
                  value:
                    jobId: '{{ request.path[3] }}'
                    resultsUri: /api/results/stanford_ner/{{ request.path[3] }}
                    status: READY
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
    delete:
      summary: Deletes the given job, or returns an error if the job is not completed. This will delete the job metadata within the NSSI database.
      operationId: deleteJob
      tags:
        - jobs
      security:
        - bearerAuth: []
      parameters:
        - name: jobId
          in: path
          schema:
            type: integer
          description: The job ID.
          required: true
      responses:
        '204':
          description: No Content
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
        '409':
          description: Conflict
  /api/jobs/{jobId}/actions/cancel:
    put:
      summary: >-
        Cancels the given in-progress job, or returns an error if the job has
        already completed.
      operationId: cancelJob
      tags:
        - jobs
      security:
        - bearerAuth: []
      parameters:
        - name: jobId
          in: path
          schema:
            type: integer
          description: The job ID.
          required: true
      responses:
        '204':
          description: No Content
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
        '409':
          $ref: '#/components/responses/Conflict'
  /api/results/{workflow}/{jobId}:
    get:
      summary: Returns the results for a job with the given job ID.
      operationId: getResults
      x-microcks-operation:
        dispatcher: SCRIPT
        dispatcherRules: |
          def path = mockRequest.getRequest().getServletPath()
          if (path.contains("stanford_ner_full") )
          {
            return "elucidate"
          }
          else if (path.contains("stanford_ner") )
          {
            return "ner"
          }
          else return "recon"
      tags:
        - results
      security:
        - bearerAuth: []
      parameters:
        - name: jobId
          in: path
          schema:
            type: integer
          examples:
            recon:
              value: 11
            ner:
              value: 11
            elucidate:
              value: 11
          description: The job ID.
          required: true
        - $ref: '#/components/parameters/workflow'
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProcessingResult'
              examples:
                ner:
                  value:
                    processingDate: null
                    metadata: null
                    data:
                      - selections:
                          - lemma: Holmes
                            selection:
                              start: 21
                              end: 27
                        classification: PERSON
                        entity: Holmes
                      - selections:
                          - lemma: Baker Street
                            selection:
                              start: 379
                              end: 391
                        classification: LOCATION
                        entity: Baker Street
                      - selections:
                          - lemma: Atkinson
                            selection:
                              start: 990
                              end: 998
                        classification: PERSON
                        entity: Atkinson
                      - selections:
                          - lemma: Holmes
                            selection:
                              start: 279
                              end: 285
                        classification: PERSON
                        entity: Holmes
                      - selections:
                          - lemma: Odessa
                            selection:
                              start: 898
                              end: 904
                        classification: LOCATION
                        entity: Odessa
                      - selections:
                          - lemma: Trincomalee
                            selection:
                              start: 1011
                              end: 1022
                        classification: LOCATION
                        entity: Trincomalee
                      - selections:
                          - lemma: Holland
                            selection:
                              start: 1135
                              end: 1142
                        classification: LOCATION
                        entity: Holland
                recon:
                  value:
                    metadata:
                      authority: wikidata-works
                      matchNumber: '3'
                      matchThreshold: '0.2'
                      authoritySource: https://query.wikidata.org/
                      authorityVersion: '2021-07-18'
                    processingDate: '2022-03-02T22:30:00.003143'
                    data:
                      - - unique_id: my_record_1
                          match_probability: '0.99'
                          author_BirthYear: '1939'
                          author_ISNI_ID: 0000 0001 2321 5491
                          author_Name1: Margaret Atwood
                          author_Name2: Margaret Eleanor Atwood
                          author_VIAF_URI: http://viaf.org/viaf/109322990
                          author_Wikidata_URI: http://www.wikidata.org/entity/Q183492
                          work_ISBN13_ID: 978-2-221-10101-8
                          work_Name1: Oryx and Crake
                          work_OCLC_Control_URL: https://www.worldcat.org/oclc/60427764
                          work_PublicationDate: '2003'
                          work_Publisher: McClelland & Stewart
                          work_Publisher_Wikidata_URI: https://www.wikidata.org/wiki/Q6800322
                          work_Wikidata_URI: http://www.wikidata.org/entity/Q2032398
                        - unique_id: my_record_1
                          match_probability: '0.77'
                          author_BirthYear: '1939'
                          author_ISNI_ID: 0000 0001 2321 5491
                          author_Name1: Margaret Atwood
                          author_Name2: Margaret Eleanor Atwood
                          author_VIAF_URI: http://viaf.org/viaf/109322990
                          author_Wikidata_URI: http://www.wikidata.org/entity/Q183492
                          work_Name1: Cat's Eye
                          work_OCLC_Control_URL: https://www.worldcat.org/oclc/19271117
                          work_PublicationDate: '1988'
                          work_CountryOrigin: Canada
                          work_CountryOrigin_Wikidata_URI: http://www.wikidata.org/entity/Q16
                          work_Wikidata_URI: http://www.wikidata.org/entity/Q1736876
                      - - unique_id: my_record_2
                          match_probability: '0.65'
                          work_Name1: Survival
                          work_Name2: >-
                            journal of the International Institute for Strategic
                            Studies
                          work_OCLC_Control_URL: https://www.worldcat.org/oclc/642473660
                          work_CountryOrigin: United Kingdom
                          work_CountryOrigin_Wikidata_URI: http://www.wikidata.org/entity/Q145
                          work_Language: English
                          work_Language_Wikidata_URI: http://www.wikidata.org/entity/Q1860
                          work_Wikidata_URI: http://www.wikidata.org/entity/Q7647172
                      - - unique_id: my_record_3
                          match_probability: '0.8'
                          author_BirthYear: '1343'
                          author_DeathYear: '1400'
                          author_ISNI_ID: 0000 0001 1557 454X, 0000 0003 7584 0787
                          author_Name1: Geoffrey Chaucer
                          author_Name2: Chaucer
                          author_VIAF_URI: http://viaf.org/viaf/100185203
                          author_Wikidata_URI: http://www.wikidata.org/entity/Q5683
                          work_Name1: The Canterbury Tales
                          work_Name2: Les Contes de Cantorbéry
                          work_Name3: Canterbury Tales
                          work_OCLC_ID: '2542108425'
                          work_PublicationDate: '1387'
                          work_VIAF_URI: http://viaf.org/viaf/180531378
                          work_CountryOrigin: England
                          work_CountryOrigin_Wikidata_URI: http://www.wikidata.org/entity/Q21
                          work_Language: Middle English
                          work_Language_Wikidata_URI: http://www.wikidata.org/entity/Q36395
                          work_Wikidata_URI: http://www.wikidata.org/entity/Q191663
                        - unique_id: my_record_3
                          match_probability: '0.68'
                          work_Name1: The Canterbury Tales
                          work_PublicationDate: '1894'
                          work_Publisher: Clarendon Press
                          work_Publisher_Wikidata_URI: http://www.wikidata.org/entity/Q10454562
                          work_Wikidata_URI: http://www.wikidata.org/entity/Q55776831
                elucidate:
                  value:
                    processingDate: '2022-03-02T22:30:00.003143'
                    metadata: {}
                    containerURI: >-
                      /api/elucidate/annotation/w3c/f6555994-ef4b-49c0-b2f3-113569939f74/
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
    delete:
      summary: >-
        Deletes the results for a job with the given job ID, or returns an error
        if the job is not completed. For results stored in the NSSI DB or on S3, this will delete those results from those locations. For results stored in Elucidate containers, send a DELETE request to the container itself.
      operationId: deleteResults
      tags:
        - results
      security:
        - bearerAuth: []
      parameters:
        - name: jobId
          in: path
          schema:
            type: integer
          description: The job ID.
          required: true
        - $ref: '#/components/parameters/workflow'
      responses:
        '204':
          description: No Content
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
        '409':
          description: Conflict
  /api/elucidate/annotation/{spec}/{containerId}:
    get:
      summary: Returns the annotation container with the given ID.
      operationId: getAnnotationContainer
      tags:
        - elucidate
      security:
        - bearerAuth: []
      parameters:
        - $ref: '#/components/parameters/annotationSpec'
        - $ref: '#/components/parameters/annotationContainerId'
      responses:
        '200':
          description: Success
          content:
            application/json:
              examples:
                success:
                  value:
                    '@context':
                      - http://www.w3.org/ns/anno.jsonld
                      - http://www.w3.org/ns/ldp.jsonld
                    id: /api/elucidate/annotation/w3c/{{ request.path[5] }}/
                    type: AnnotationCollection
                    label: >-
                      https://www.wwp.northeastern.edu/outreach/seminars/_current/handouts/tei_samples/invitro/golden_treasury.xml
                    first:
                      type: AnnotationPage
                      items:
                        - id: >-
                            /api/elucidate/annotation/w3c/{{ request.path[5]
                            }}/1f6cdb51-2d81-4ccb-81ff-114d890e928d
                          type: Annotation
                          created: '2022-03-02 21:33:08'
                          creator:
                            id: http://localhost:8080
                            type: Software
                            schema:softwareVersion:
                              '@language': en
                              '@value': v2.0.0
                            label:
                              '@language': en
                              '@value': NSSI Local Instance
                          generated: '2022-03-02 21:33:08'
                          body:
                            type: Choice
                            as:items:
                              - id: http://viaf.org/viaf/309735143/
                                type: >-
                                  http://sparql.cwrc.ca/ontologies/cwrc#PersonalName
                                format:
                                  '@language': en
                                  '@value': text/plain
                                label:
                                  '@language': en
                                  '@value': Hallam, Henry
                              - id: http://viaf.org/viaf/100390015/
                                type: >-
                                  http://sparql.cwrc.ca/ontologies/cwrc#PersonalName
                                format:
                                  '@language': en
                                  '@value': text/plain
                                label:
                                  '@language': en
                                  '@value': Hallam, Henry
                              - id: http://viaf.org/viaf/96500693/
                                type: >-
                                  http://sparql.cwrc.ca/ontologies/cwrc#PersonalName
                                format:
                                  '@language': en
                                  '@value': text/plain
                                label:
                                  '@language': en
                                  '@value': >-
                                    Murray, A. H. Hallam (Alexander Henry
                                    Hallam), 1854-1934
                          target:
                            type: SpecificResource
                            format:
                              '@language': en
                              '@value': application/tei+xml
                            selector:
                              type: XPathSelector
                              oa:value:
                                '@language': en
                                '@value': /TEI/text/body/div/listPerson/person[2]
                            oa:motivatedBy:
                              type: Motivation
                              '@value': oa:identifying
                        - id: >-
                            /api/elucidate/annotation/w3c/{{ request.path[5]
                            }}/18eb320f-58fa-4c5f-8f42-71a408d37dba
                          type: Annotation
                          created: '2022-03-02 21:33:09'
                          creator:
                            id: http://localhost:8080
                            type: Software
                            schema:softwareVersion:
                              '@language': en
                              '@value': v2.0.0
                            label:
                              '@language': en
                              '@value': NSSI Local Instance
                          generated: '2022-03-02 21:33:09'
                          body:
                            type: Choice
                            as:items:
                              - id: http://viaf.org/viaf/291208770/
                                type: owl:Thing
                                format:
                                  '@language': en
                                  '@value': text/plain
                                label:
                                  '@language': en
                                  '@value': Two Englishmen
                              - id: http://viaf.org/viaf/90490526/
                                type: owl:Thing
                                format:
                                  '@language': en
                                  '@value': text/plain
                                label:
                                  '@language': en
                                  '@value': Friend to the true rights of Englishmen
                              - id: http://viaf.org/viaf/79966607/
                                type: owl:Thing
                                format:
                                  '@language': en
                                  '@value': text/plain
                                label:
                                  '@language': en
                                  '@value': Petrow, Joachim
                          target:
                            type: SpecificResource
                            format:
                              '@language': en
                              '@value': application/tei+xml
                            selector:
                              type: XPathSelector
                              oa:value:
                                '@language': en
                                '@value': /TEI/text/body/div/listPerson/person[1]
                            oa:motivatedBy:
                              type: Motivation
                              '@value': oa:identifying
                        - id: >-
                            /api/elucidate/annotation/w3c/{{ request.path[5]
                            }}/e9356f34-1f4f-4665-9994-66097d423303
                          type: Annotation
                          created: '2022-03-02 21:33:09'
                          creator:
                            id: http://localhost:8080
                            type: Software
                            schema:softwareVersion:
                              '@language': en
                              '@value': v2.0.0
                            label:
                              '@language': en
                              '@value': NSSI Local Instance
                          generated: '2022-03-02 21:33:09'
                          body:
                            type: Choice
                            as:items:
                              id: http://www.wikidata.org/entity/Q17644367
                              type: >-
                                http://sparql.cwrc.ca/ontologies/cwrc#PersonalName
                              format:
                                '@language': en
                                '@value': text/plain
                              rdfs:comment:
                                '@language': en
                                '@value': promontory fort in Cornwall
                              label:
                                '@language': en
                                '@value': Treryn Dinas
                          target:
                            type: SpecificResource
                            format:
                              '@language': en
                              '@value': application/tei+xml
                            selector:
                              type: XPathSelector
                              oa:value:
                                '@language': en
                                '@value': /TEI/text/body/div[2]/listPerson/person[3]
                            oa:motivatedBy:
                              type: Motivation
                              '@value': oa:identifying
                      next: >-
                        /api/elucidate/annotation/w3c/{{ request.path[5]
                        }}/?page=1&desc=1
                      partOf: /api/elucidate/annotation/w3c/{{ request.path[5] }}/
                      startIndex: 0
                    last: >-
                      /api/elucidate/annotation/w3c/{{ request.path[5]
                      }}/?page=1&desc=1
                    total: 3
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
    post:
      summary: Creates a new annotation in the given container.
      operationId: createAnnotation
      tags:
        - elucidate
      security:
        - bearerAuth: []
      parameters:
        - $ref: '#/components/parameters/annotationSpec'
        - $ref: '#/components/parameters/annotationContainerId'
      requestBody:
        required: true
        content:
          application/json:
            schema:
              properties:
                property:
                  type: string
                  description: TODO
                  example: TODO
            examples:
              success:
                value:
                  TODO: []
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                properties: {}
              examples:
                success:
                  value:
                    TODO: []
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
  /api/elucidate/annotation/{spec}/{containerId}/{annotationId}:
    get:
      summary: Returns the annotation with the given ID.
      operationId: getAnnotation
      tags:
        - elucidate
      security:
        - bearerAuth: []
      parameters:
        - $ref: '#/components/parameters/annotationSpec'
        - $ref: '#/components/parameters/annotationContainerId'
        - $ref: '#/components/parameters/annotationId'
      responses:
        '200':
          description: Success
          content:
            application/json:
              examples:
                first:
                  value:
                    id: >-
                      /api/elucidate/annotation/w3c/{{ request.path[5]
                      }}/1f6cdb51-2d81-4ccb-81ff-114d890e928d
                    type: Annotation
                    created: '2022-03-02 21:33:08'
                    creator:
                      id: http://localhost:8080
                      type: Software
                      schema:softwareVersion:
                        '@language': en
                        '@value': v2.0.0
                      label:
                        '@language': en
                        '@value': NSSI Local Instance
                    generated: '2022-03-02 21:33:08'
                    body:
                      type: Choice
                      as:items:
                        - id: http://viaf.org/viaf/309735143/
                          type: http://sparql.cwrc.ca/ontologies/cwrc#PersonalName
                          format:
                            '@language': en
                            '@value': text/plain
                          label:
                            '@language': en
                            '@value': Hallam, Henry
                        - id: http://viaf.org/viaf/100390015/
                          type: http://sparql.cwrc.ca/ontologies/cwrc#PersonalName
                          format:
                            '@language': en
                            '@value': text/plain
                          label:
                            '@language': en
                            '@value': Hallam, Henry
                        - id: http://viaf.org/viaf/96500693/
                          type: http://sparql.cwrc.ca/ontologies/cwrc#PersonalName
                          format:
                            '@language': en
                            '@value': text/plain
                          label:
                            '@language': en
                            '@value': >-
                              Murray, A. H. Hallam (Alexander Henry Hallam),
                              1854-1934
                    target:
                      type: SpecificResource
                      format:
                        '@language': en
                        '@value': application/tei+xml
                      selector:
                        type: XPathSelector
                        oa:value:
                          '@language': en
                          '@value': /TEI/text/body/div/listPerson/person[2]
                      oa:motivatedBy:
                        type: Motivation
                        '@value': oa:identifying
                second:
                  value:
                    id: >-
                      /api/eludicate/annotation/w3c/{{ request.path[5]
                      }}/18eb320f-58fa-4c5f-8f42-71a408d37dba
                    type: Annotation
                    created: '2022-03-02 21:33:09'
                    creator:
                      id: http://localhost:8080
                      type: Software
                      schema:softwareVersion:
                        '@language': en
                        '@value': v2.0.0
                      label:
                        '@language': en
                        '@value': NSSI Local Instance
                    generated: '2022-03-02 21:33:09'
                    body:
                      type: Choice
                      as:items:
                        - id: http://viaf.org/viaf/291208770/
                          type: owl:Thing
                          format:
                            '@language': en
                            '@value': text/plain
                          label:
                            '@language': en
                            '@value': Two Englishmen
                        - id: http://viaf.org/viaf/90490526/
                          type: owl:Thing
                          format:
                            '@language': en
                            '@value': text/plain
                          label:
                            '@language': en
                            '@value': Friend to the true rights of Englishmen
                        - id: http://viaf.org/viaf/79966607/
                          type: owl:Thing
                          format:
                            '@language': en
                            '@value': text/plain
                          label:
                            '@language': en
                            '@value': Petrow, Joachim
                    target:
                      type: SpecificResource
                      format:
                        '@language': en
                        '@value': application/tei+xml
                      selector:
                        type: XPathSelector
                        oa:value:
                          '@language': en
                          '@value': /TEI/text/body/div/listPerson/person[3]
                      oa:motivatedBy:
                        type: Motivation
                        '@value': oa:identifying
                third:
                  value:
                    id: >-
                      /api/elucidate/annotation/w3c/{{ request.path[5]
                      }}/e9356f34-1f4f-4665-9994-66097d423303
                    type: Annotation
                    created: '2022-03-02 21:33:09'
                    creator:
                      id: http://localhost:8080
                      type: Software
                      schema:softwareVersion:
                        '@language': en
                        '@value': v2.0.0
                      label:
                        '@language': en
                        '@value': NSSI Local Instance
                    generated: '2022-03-02 21:33:09'
                    body:
                      type: Choice
                      as:items:
                        id: http://www.wikidata.org/entity/Q17644367
                        type: http://sparql.cwrc.ca/ontologies/cwrc#PersonalName
                        format:
                          '@language': en
                          '@value': text/plain
                        rdfs:comment:
                          '@language': en
                          '@value': promontory fort in Cornwall
                        label:
                          '@language': en
                          '@value': Treryn Dinas
                    target:
                      type: SpecificResource
                      format:
                        '@language': en
                        '@value': application/tei+xml
                      selector:
                        type: XPathSelector
                        oa:value:
                          '@language': en
                          '@value': /TEI/text/body/div[2]/listPerson/person[1]
                      oa:motivatedBy:
                        type: Motivation
                        '@value': oa:identifying
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
    put:
      summary: Updates the given annotation.
      operationId: updateAnnotation
      tags:
        - elucidate
      security:
        - bearerAuth: []
      parameters:
        - $ref: '#/components/parameters/annotationSpec'
        - $ref: '#/components/parameters/annotationContainerId'
        - $ref: '#/components/parameters/annotationId'
      requestBody:
        required: true
        content:
          application/json:
            examples:
              success:
                value: TODO
      responses:
        '200':
          description: Success
          content:
            application/json:
              examples:
                success:
                  value:
                    TODO: []
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
    delete:
      summary: Marks the given annotation as deleted.
      operationId: deleteAnnotation
      tags:
        - elucidate
      security:
        - bearerAuth: []
      parameters:
        - $ref: '#/components/parameters/annotationSpec'
        - $ref: '#/components/parameters/annotationContainerId'
        - $ref: '#/components/parameters/annotationId'
      responses:
        '204':
          description: No Content
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
  /api/uploads/{uploadId}:
    get:
      summary: Download the file corresponding to the given upload ID.
      operationId: getUpload
      tags:
        - uploads
      security:
        - bearerAuth: []
      parameters:
        - $ref: '#/components/parameters/uploadId'
      responses:
        '200':
          description: Success
          content:
            application/octet-stream:
              schema:
                type: string
                description: The file corresponding to the given upload ID.
                format: binary
                example: <file contents>
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
    delete:
      summary: Deletes the file from S3 which corresponds to the given upload ID.
      operationId: deleteUpload
      tags:
        - uploads
      security:
        - bearerAuth: []
      parameters:
        - $ref: '#/components/parameters/AuthHeader'
        - $ref: '#/components/parameters/uploadId'
      responses:
        '204':
          description: No Content
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
  /api/projects/:
    get:
      summary: Get a list of projects.
      operationId: getProjectsList
      tags:
        - projects
      security:
        - bearerAuth: []
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/ProjectInfo'
              examples:
                success:
                  value:
                    - projectId: 42
                      projectName: Mock Project
                      projectResources:
                        - projectResourceId: abcdefg
                          sourceDocumentUri: https://the.document
                          resultsUri: >-
                            /api/elucidate/annotation/w3c/f6555994-ef4b-49c0-b2f3-113569939f74/
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
    post:
      summary: Create a new project.
      operationId: createProject
      tags:
        - projects
      security:
        - bearerAuth: []
      parameters:
        - $ref: '#/components/parameters/AuthHeader'
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ProjectCreationRequest'
            examples:
              success:
                value:
                  TODO: []
      responses:
        '201':
          description: Created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProjectInfo'
              examples:
                success:
                  value:
                    TODO: []
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
  /api/projects/{projectId}:
    get:
      summary: Get information about the given project.
      operationId: getProject
      tags:
        - projects
      security:
        - bearerAuth: []
      parameters:
        - $ref: '#/components/parameters/projectId'
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProjectInfo'
              examples:
                success:
                  value:
                    projectId: 42
                    projectName: Mock Project
                    projectResources:
                      - projectResourceId: abcdefg
                        sourceDocumentUri: https://the.document
                        resultsUri: >-
                          /api/elucidate/annotation/w3c/f6555994-ef4b-49c0-b2f3-113569939f74/
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
    delete:
      summary: Delete the project corresponding to the given project ID.
      operationId: deleteProject
      tags:
        - projects
      security:
        - bearerAuth: []
      parameters:
        - $ref: '#/components/parameters/projectId'
      responses:
        '204':
          description: No Content
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
  /api/projects/{projectId}/resources/:
    get:
      summary: Get a list of resources for the given project.
      operationId: getProjectResourcesList
      tags:
        - projects
      security:
        - bearerAuth: []
      parameters:
        - $ref: '#/components/parameters/projectId'
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/ProjectResourceInfo'
              examples:
                success:
                  value:
                    - projectResourceId: abcdefg
                      sourceDocumentUri: https://the.document
                      resultsUri: >-
                        /api/elucidate/annotation/w3c/f6555994-ef4b-49c0-b2f3-113569939f74/
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
    post:
      summary: Create a new resource in the given project.
      operationId: createProjectResource
      tags:
        - projects
      security:
        - bearerAuth: []
      parameters:
        - $ref: '#/components/parameters/projectId'
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ProjectResourceCreationRequest'
            examples:
              success:
                value:
                  TODO: []
      responses:
        '201':
          description: Created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProjectResourceInfo'
              examples:
                success:
                  value:
                    TODO: []
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
  /api/projects/{projectId}/resources/{resourceId}:
    get:
      summary: Get information about the given resource within the given project.
      operationId: getProjectResource
      tags:
        - projects
      security:
        - bearerAuth: []
      parameters:
        - $ref: '#/components/parameters/projectId'
        - $ref: '#/components/parameters/resourceId'
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProjectResourceInfo'
              examples:
                success:
                  value:
                    projectResourceId: abcdefg
                    sourceDocumentUri: https://the.document
                    resultsUri: >-
                      /api/elucidate/annotation/w3c/f6555994-ef4b-49c0-b2f3-113569939f74/
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
    delete:
      summary: Delete the given resource within the given project.
      operationId: deleteProjectResource
      tags:
        - projects
      security:
        - bearerAuth: []
      parameters:
        - $ref: '#/components/parameters/projectId'
        - $ref: '#/components/parameters/resourceId'
      responses:
        '204':
          description: No Content
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
  /api/workflows:
    get:
      summary: Returns a list of workflows which the user is authorized to use.
      operationId: getWorkflows
      tags:
        - authorizations
      security:
        - bearerAuth: []
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/WorkflowInfoMap'
              examples:
                success:
                  value:
                    "/api/workflows/stanford_ner_full":
                      shortName: stanford_ner_full
                      fullName: Stanford NER + Linking + Annotations
                      pipeline: stanfordner,simple_linking,annotation
                      resultsTypeName: elucidate
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '404':
          $ref: '#/components/responses/NotFoundError'
components:
  parameters:
    AuthHeader:
      in: header
      name: Authorization
      schema:
        type: string
      examples:
        success:
          value: Bearer XXXXXX
        error:
          value: Bearer XXXXXX
        ner:
          value: Bearer XXXXXX
        recon:
          value: Bearer XXXXXX
        elucidate:
          value: Bearer XXXXXX
    jobId:
      in: path
      name: jobId
      schema:
        type: integer
      examples:
        success:
          value: 11
        elucidate:
          value: 11
        ner:
          value: 11
        recon:
          value: 11
        results_elucidate:
          value: 11
        results_ner:
          value: 11
        results_recon:
          value: 11
      description: The job ID.
      required: true
    workflow:
      in: path
      name: workflow
      schema:
        type: string
      examples:
        success:
          value: stanford_ner
        error:
          value: not_a_workflow
        ner:
          value: stanford_ner
        recon:
          value: reconciliation
        elucidate:
          value: stanford_ner_full
        results_ner:
          value: stanford_ner
        results_recon:
          value: reconciliation
        results_elucidate:
          value: stanford_ner_full
      description: The name of the workflow.
      required: true
    uploadId:
      in: path
      name: uploadId
      schema:
        type: integer
      examples:
        success:
          value: 153
      description: The ID of the uploaded file.
      required: true
    projectId:
      in: path
      name: projectId
      schema:
        type: integer
      examples:
        success:
          value: 42
      description: The ID of the project.
      required: true
    resourceId:
      in: path
      name: resourceId
      schema:
        type: string
      examples:
        success:
          value: AAAA-BBBB-CCCC-DDDD
      description: The ID of the project resource.
      required: true
    annotationSpec:
      in: path
      name: spec
      schema:
        type: string
      examples:
        success:
          value: w3c
        first:
          value: w3c
        second:
          value: w3c
        third:
          value: w3c
      description: The annotation specification to use, either "w3c" or "oa".
      required: true
    annotationContainerId:
      in: path
      name: containerId
      schema:
        type: string
      examples:
        success:
          value: 18e7ba0a-269d-4912-afc5-a480a373fa1a
        first:
          value: 18e7ba0a-269d-4912-afc5-a480a373fa1a
        second:
          value: 18e7ba0a-269d-4912-afc5-a480a373fa1a
        third:
          value: 18e7ba0a-269d-4912-afc5-a480a373fa1a
      description: The ID of the container to retrieve.
      required: true
    annotationId:
      in: path
      name: annotationId
      schema:
        type: string
      examples:
        first:
          value: 1f6cdb51-2d81-4ccb-81ff-114d890e928d
        second:
          value: 18eb320f-58fa-4c5f-8f42-71a408d37dba
        third:
          value: e9356f34-1f4f-4665-9994-66097d423303
      description: The ID of the annotation to retrieve.
      required: true
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT
  responses:
    BadRequestError:
      description: Bad data in request body, or required headers are missing.
    UnauthorizedError:
      description: Access token is invalid.
    NotFoundError:
      description: Requested resource could not be found.
    Conflict:
      description: >-
        There is a conflict between the request and the state of the server. See
        the response for details on how to resolve the issue.
    ServiceError:
      description: Internal service error.
  schemas:
    SubmissionRequest:
      type: object
      required:
        - format
        - workflow
      properties:
        projectName:
          type: string
          description: The project name.
          example: Test Project
        format:
          type: string
          description: The MIME type of the document to be processed.
          example: application/tei+xml
        document:
          type: string
          description: >-
            The contents of the document to be processed, which should match the
            document that the documentURI element points to. Can be omitted or
            set to null.
          example: null
        documentURI:
          type: string
          description: A URI for the document to be processed.
          example: >-
            https://www.wwp.northeastern.edu/outreach/seminars/_current/handouts/tei_samples/invitro/golden_treasury.xml
        authorities:
          type: array
          items:
            type: string
          example:
            - VIAF
            - WIKIDATA
            - GEONAMES
        context:
          type: object
          additionalProperties:
            type: string
          example:
            ORGANIZATION_TAG: orgName
            LOCATION_TAG: placeName
            PERSON_TAG: persName
            TITLE_TAG: title
        workflow:
          type: string
          description: The workflow to use when processing the request.
          example: stanford_ner_remote
    ProjectCreationRequest:
      properties:
        projectName:
          type: string
          description: The name of the project to be created.
          example: Canadian Women's Literature
    ProjectResourceCreationRequest:
      properties:
        sourceDocumentUri:
          type: string
          description: The URI of the source document.
          format: uri
        resultsUri:
          type: string
          description: The URI of the processing results.
          format: uri
    ActuatorInfoResponse:
      type: object
      properties:
        git:
          type: object
          properties:
            commit:
              type: object
              properties:
                full:
                  type: string
                  description: Full git commit SHA for the build that is currently running.
                  example: 3566a76bb03f0ac076e99fb7d6b24b9c4c44c5ac
                abbrev:
                  type: string
                  description: >-
                    Short git commit SHA for the build that is currently
                    running.
                  example: 3566a76
        build:
          type: object
          properties:
            artifact:
              type: string
              description: The artifact ID.
              example: Service
            name:
              type: string
              description: The artifact name.
              example: Service
            time:
              type: string
              description: The timestamp of the build.
              format: date-time
              example: '2020-11-11T12:43:31.049Z'
            version:
              type: string
              description: The app version of the build.
              example: 1.0.0-SNAPSHOT
            group:
              type: string
              description: The application group.
              example: ca.sharcnet.nerve
    JobInfo:
      properties:
        jobId:
          type: integer
          description: The generated job ID for the submitted job.
          example: 42
        resultsUri:
          type: string
          description: >-
            The URI from where results can be retrieved when processing
            completes.
          format: uri
          example: >-
            http://elucidate.lincsproject.ca/annotation/w3c/18e7ba0a-269d-4912-afc5-a480a373fa1a/
        status:
          type: string
          description: A string indicating the status of the job.
          enum:
            - IN_PROGRESS
            - READY
            - CANCELLED
            - FAILED
          example: READY
    ProjectInfo:
      properties:
        projectId:
          type: integer
          description: The project ID.
          example: 42
        projectName:
          type: string
          description: The name for the project.
          example: Canadian Women's Literature
        projectResources:
          type: array
          items:
            $ref: '#/components/schemas/ProjectResourceInfo'
    ProjectResourceInfo:
      properties:
        projectResourceId:
          type: string
          description: The ID for the project resource.
        sourceDocumentUri:
          type: string
          description: The URI of the source document.
          format: uri
        resultsUri:
          type: string
          description: The URI of the results.
          format: uri
    ProcessingResult:
      type: object
      description: >-
        A response containing job processing results. Contents of this response
        will vary based on workflow.
      properties:
        processingDate:
          type: string
          description: The processing date for the results.
          format: date-time
      additionalProperties:
        type: string
      example:
        processingDate: '2020-11-26T19:46:14.448538'
        metadata: null
        containerUri: >-
          http://elucidate.lincsproject.ca/annotation/w3c/18e7ba0a-269d-4912-afc5-a480a373fa1a/
    WorkflowInfoMap:
      type: object
      description: A map containing a list of workflow descriptions.
      additionalProperties:
        type: object
        properties:
          shortName:
            type: string
          fullName:
            type: string
          pipeline:
            type: string
          resultsTypeName:
            type: string
